aboutsummaryrefslogtreecommitdiff
path: root/.local/bin/compiler
diff options
context:
space:
mode:
authorCaleb Noelke <cjn075@firemail.cc>2024-10-21 12:54:52 -0400
committerCaleb Noelke <cjn075@firemail.cc>2024-10-21 12:54:52 -0400
commitfe96c467eec5d66864dde93b4b5186524e258fd1 (patch)
treef9c7550e03241bb087ade674b459667b1f63ae9a /.local/bin/compiler
parent398886b6d4631bb1e695bf7851f1012c64f6895a (diff)
parent628ed4dc995f3c09e33c24a01c817c18b1a268af (diff)
Diffstat (limited to '.local/bin/compiler')
-rwxr-xr-x.local/bin/compiler83
1 files changed, 38 insertions, 45 deletions
diff --git a/.local/bin/compiler b/.local/bin/compiler
index 8420e25..5713590 100755
--- a/.local/bin/compiler
+++ b/.local/bin/compiler
@@ -2,58 +2,51 @@
# This script will compile or run another finishing operation on a document. I
# have this script run via vim.
-#
+
# Compiles .tex. groff (.mom, .ms), .rmd, .md, .org. Opens .sent files as sent
# presentations. Runs scripts based on extension or shebang.
-#
+
# Note that .tex files which you wish to compile with XeLaTeX should have the
# string "xelatex" somewhere in a comment/command in the first 5 lines.
-file=$(readlink -f "$1")
+file="${1}"
+ext="${file##*.}"
dir=${file%/*}
base="${file%.*}"
-ext="${file##*.}"
-
-cd "$dir" || exit 1
-textype() { \
- textarget="$(getcomproot "$file" || echo "$file")"
- echo "$textarget"
- command="pdflatex"
- ( head -n5 "$textarget" | grep -qi 'xelatex' ) && command="xelatex"
- $command --output-directory="${textarget%/*}" "${textarget%.*}"
- grep -qi addbibresource "$textarget" &&
- biber --input-directory "${textarget%/*}" "${textarget%.*}" &&
- $command --output-directory="${textarget%/*}" "${textarget%.*}" &&
- $command --output-directory="${textarget%/*}" "${textarget%.*}"
-}
+cd "${dir}" || exit "1"
-case "$ext" in
- # Try to keep these cases in alphabetical order.
- [0-9]) preconv "$file" | refer -PS -e | groff -mandoc -T pdf > "$base".pdf ;;
- c) cc "$file" -o "$base" && "$base" ;;
- cpp) g++ "$file" -o "$base" && "$base" ;;
- cs) mcs "$file" && mono "$base".exe ;;
- go) go run "$file" ;;
- h) sudo make install ;;
- java) javac -d classes "$file" && java -cp classes "${1%.*}" ;;
- m) octave "$file" ;;
- md) if [ -x "$(command -v lowdown)" ]; then
- lowdown --parse-no-intraemph "$file" -Tms | groff -mpdfmark -ms -kept -T pdf > "$base".pdf
- elif [ -x "$(command -v groffdown)" ]; then
- groffdown -i "$file" | groff -T pdf > "$base".pdf
- else
- pandoc -t ms --highlight-style=kate -s -o "$base".pdf "$file"
- fi ; ;;
- mom) preconv "$file" | refer -PS -e | groff -mom -kept -T pdf > "$base".pdf ;;
- ms) preconv "$file" | refer -PS -e | groff -me -ms -kept -T pdf > "$base".pdf ;;
- org) emacs "$file" --batch -u "$USER" -f org-latex-export-to-pdf ;;
- py) python "$file" ;;
- [rR]md) Rscript -e "rmarkdown::render('$file', quiet=TRUE)" ;;
- rs) cargo build ;;
- sass) sassc -a "$file" "$base".css ;;
- scad) openscad -o "$base".stl "$file" ;;
- sent) setsid -f sent "$file" 2>/dev/null ;;
- tex) textype "$file" ;;
- *) sed -n '/^#!/s/^#!//p; q' "$file" | xargs -r -I % "$file" ;;
+case "${ext}" in
+ [0-9]) preconv "${file}" | refer -PS -e | groff -mandoc -T pdf > "${base}.pdf" ;;
+ mom|ms) preconv "${file}" | refer -PS -e | groff -T pdf -m"${ext}" > "${base}.pdf" ;;
+ c) cc "${file}" -o "${base}" && "./${base}" ;;
+ cpp) g++ "${file}" -o "${base}" && "./${base}" ;;
+ cs) mcs "${file}" && mono "${base}.exe" ;;
+ go) go run "${file}" ;;
+ h) sudo make install ;;
+ java) javac -d classes "${file}" && java -cp classes "${base}" ;;
+ m) octave "${file}" ;;
+ md) [ -x "$(command -v lowdown)" ] && \
+ lowdown --parse-no-intraemph "${file}" -Tms | groff -mpdfmark -ms -kept -T pdf > "${base}.pdf" || \
+ [ -x "$(command -v groffdown)" ] && \
+ groffdown -i "${file}" | groff -T pdf > "${base}.pdf" || \
+ pandoc -t ms --highlight-style="kate" -s -o "${base}.pdf" "${file}" ;;
+ org) emacs "${file}" --batch -u "${USER}" -f org-latex-export-to-pdf ;;
+ py) python "${file}" ;;
+ [rR]md) Rscript -e "rmarkdown::render('${file}', quiet=TRUE)" ;;
+ rs) cargo build ;;
+ sass) sassc -a "${file}" "${base}.css" ;;
+ scad) openscad -o "${base}.stl" "${file}" ;;
+ sent) setsid -f sent "${file}" 2> "/dev/null" ;;
+ tex)
+ textarget="$(getcomproot "${file}" || echo "${file}")"
+ command="pdflatex"
+ head -n5 "${textarget}" | grep -qi "xelatex" && command="xelatex"
+ ${command} --output-directory="${textarget%/*}" "${textarget%.*}" &&
+ grep -qi addbibresource "${textarget}" &&
+ biber --input-directory "${textarget%/*}" "${textarget%.*}" &&
+ ${command} --output-directory="${textarget%/*}" "${textarget%.*}" &&
+ ${command} --output-directory="${textarget%/*}" "${textarget%.*}"
+ ;;
+ *) sed -n '/^#!/s/^#!//p; q' "${file}" | xargs -r -I % "${file}" ;;
esac